//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\IniFiles.hpp>
#include <stdio.h>
#include <string.h>

#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma link "Grids"
#pragma link "Port_32"
#pragma resource "*.dfm"
TForm1 *Form1;

Word     PortWSel,PortRSel;
Byte     ValWSel;
Byte     NomWSel,NomRSel;
Boolean  FlagPrint=FALSE;
Word     NumLine;
Word     NumSymbol;
String	PrintLine;

TCheckBox *CPinRead[26],*CPinWrite[26];

void ShowButtons()
{
   Form1->GroupBox1->Enabled=Form1->HwCtrl->ActiveHW;
   Form1->B_Write->Enabled=Form1->HwCtrl->ActiveHW;
   Form1->B_Read->Enabled=Form1->HwCtrl->ActiveHW;
   Form1->B_WriteAll->Enabled=Form1->HwCtrl->ActiveHW;
   Form1->B_ReadAll->Enabled=Form1->HwCtrl->ActiveHW;
}
ULONG CharToNumber(char ch)
  {
    int n,i;
    char hexh[17] = "0123456789ABCDEF";
    n = 0;
    for (i=0;i<=15;i++){ if (UpperCase(ch)==hexh[i]) n=i; }
    return n;
  }

int HexToInt(AnsiString s)
{

  int i,r,k;
  char    ch;

  k=1; r=0;
  for (i=s.Length();i>0; i--){
    ch=s[i];
    r=r+CharToNumber(ch)*k; if (i>1) k*=16;
  }
  return r;
}



//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormActivate(TObject *Sender)
{

  Word i;

  if (!HwCtrl->ActiveHW)
  {
    MessageBeep(0);
    Application->MessageBox("Driver ""VICPRTxx"" not found",
                      " Warning! ",IDOK);
    Label6->Caption = "Driver not opened";
  }
  else {
         Timer1->Enabled = TRUE;
         Label6->Caption = "Driver opened";
         Label6->Font->Color = clGreen;
//         for i = 1 to 17 do VicLPT1.Pin[i] = FALSE;
       };

 CPinRead[ 1] = RPin1;    CPinWrite[ 1] = WPin1;
 CPinRead[ 2] = RPin2;    CPinWrite[ 2] = WPin2;
 CPinRead[ 3] = RPin3;    CPinWrite[ 3] = WPin3;
 CPinRead[ 4] = RPin4;    CPinWrite[ 4] = WPin4;
 CPinRead[ 5] = RPin5;    CPinWrite[ 5] = WPin5;
 CPinRead[ 6] = RPin6;    CPinWrite[ 6] = WPin6;
 CPinRead[ 7] = RPin7;    CPinWrite[ 7] = WPin7;
 CPinRead[ 8] = RPin8;    CPinWrite[ 8] = WPin8;
 CPinRead[ 9] = RPin9;    CPinWrite[ 9] = WPin9;
 CPinRead[10] = RPin10;   CPinWrite[10] = WPin10; WPin10->Enabled = FALSE;
 CPinRead[11] = RPin11;   CPinWrite[11] = WPin11; WPin11->Enabled = FALSE;
 CPinRead[12] = RPin12;   CPinWrite[12] = WPin12; WPin12->Enabled = FALSE;
 CPinRead[13] = RPin13;   CPinWrite[13] = WPin13; WPin13->Enabled = FALSE;
 CPinRead[14] = RPin14;   CPinWrite[14] = WPin14;
 CPinRead[15] = RPin15;   CPinWrite[15] = WPin15; WPin15->Enabled = FALSE;
 CPinRead[16] = RPin16;   CPinWrite[16] = WPin16;
 CPinRead[17] = RPin17;   CPinWrite[17] = WPin17;

if ((GetVersion() & 0x80000000) != 0) Label5->Caption = "Detected: Windows 95";
                else Label5->Caption = "Detected: Windows NT";

 TIniFile* MyIniFile = new TIniFile("HW_test");
 GWrite->Cells[1][0]="PORT";
 GWrite->Cells[2][0]="VAL";
 GRead->Cells[1][0]="PORT";
 GRead->Cells[2][0]="VAL";

 for (i=1; i<=16; i++){
  GWrite->Cells[0][i]=IntToStr(i);
  GWrite->Cells[1][i]=MyIniFile->ReadString("PortW","Port"+IntToStr(i),"0000");
  GWrite->Cells[2][i]=MyIniFile->ReadString("Values","Val"+IntToStr(i),"00");
  GRead->Cells[0][i]=IntToStr(i);
  GRead->Cells[1][i]=MyIniFile->ReadString("PortR","Port"+IntToStr(i),"0000");
  GRead->Cells[2][i]="..";
 }

 delete MyIniFile;

 ShowButtons();

}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn3Click(TObject *Sender)
{
 int i;
 TIniFile* MyIniFile = new TIniFile("HW_test");
 for (i=1; i<=16; i++) {
    MyIniFile->WriteString("PortW","Port"+IntToStr(i),GWrite->Cells[1][i]);
    MyIniFile->WriteString("Values","Val"+IntToStr(i),GWrite->Cells[2][i]);
    MyIniFile->WriteString("PortR","Port"+IntToStr(i),GRead->Cells[1][i]);
 }
 delete MyIniFile;
 Close();        
	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::B_WriteClick(TObject *Sender)
{
   PortWSel=(Word)HexToInt(GWrite->Cells[1][GWrite->Row]);
   GWrite->Cells[1][GWrite->Row]=IntToHex(PortWSel,4);
   ValWSel=(UCHAR)HexToInt(GWrite->Cells[2][GWrite->Row]);
   GWrite->Cells[2][GWrite->Row]=IntToHex(ValWSel,2);
   NomWSel=(Word)GWrite->Row;
   if (PortWSel==0) {MessageBeep(0); return;}
   HwCtrl->Port[PortWSel]=(UCHAR) ValWSel;
	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::B_ReadClick(TObject *Sender)
{
   PortRSel=(Word)HexToInt(GRead->Cells[1][GRead->Row]);
   GRead->Cells[1][GRead->Row]=IntToHex(PortRSel,4);
   NomRSel=(Word)GRead->Row;
   if (PortRSel==0) { MessageBeep(0); return; }
   GRead->Cells[2][GRead->Row]=IntToHex((int)HwCtrl->Port[PortRSel],2);

}
//---------------------------------------------------------------------------
void __fastcall TForm1::B_ReadAllClick(TObject *Sender)
{
 UCHAR cl[17];
 Word  ports[17],P,N,i;

 N=0;
 for (i=1; i<=16; i++) {
   P=(Word)HexToInt(GRead->Cells[1][i]);
   GRead->Cells[1][i]=IntToHex(P,4);
   if(P) {ports[++N]=P; cl[N]=(UCHAR) i;}
 }
 for (i=1; i<=N; i++)
   GRead->Cells[2][cl[i]]=IntToHex((int)HwCtrl->Port[ports[i]],2);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::B_WriteAllClick(TObject *Sender)
{
  Word i,P,V;
  for (i=1; i<=16; i++) {
    P=(Word)HexToInt(GWrite->Cells[1][i]); GWrite->Cells[1][i]=IntToHex(P,4);
    if (P) {
      V=(Word)HexToInt(GWrite->Cells[2][i]); GWrite->Cells[2][i]=IntToHex(V,2);
      HwCtrl->Port[P]=V;
    }
   }

}
//---------------------------------------------------------------------------
void __fastcall TForm1::C_HardClick(TObject *Sender)
{
 HwCtrl->HardAccess = C_Hard->Checked;	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{

Byte  nPin;
unsigned char ch;

  for (nPin=1;nPin<=17;nPin++)
    CPinRead[nPin]->Checked = VicLPT1->Pin[nPin];

  C_BUSY->Checked  = VicLPT1->BUSY();
  C_PE->Checked     = VicLPT1->PE();
  C_ERROR->Checked  = VicLPT1->_ERROR();

  if (FlagPrint)
  {
    Timer1->Enabled = FALSE;
    while (NumSymbol<PrintLine.Length())
    {
      Application->ProcessMessages();
      ch = PrintLine[NumSymbol];
      if (VicLPT1->PrintChar(ch))++NumSymbol;
    };
    Timer1->Enabled = TRUE;
    FlagPrint = FALSE;
  };

  B_Stop->Enabled = FlagPrint;
  B_Print->Enabled = !FlagPrint;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::C_InitClick(TObject *Sender)
{
  VicLPT1->_INIT();	
}
//---------------------------------------------------------------------------3
void __fastcall TForm1::B_ClearClick(TObject *Sender)
{
  TextMemo->Clear();	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::B_PrintClick(TObject *Sender)
{
  if (FlagPrint) return;
  PrintLine = TextMemo->Lines[0].Text;
  NumLine=0;
  NumSymbol=1;
  FlagPrint=TRUE;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::B_StopClick(TObject *Sender)
{
  FlagPrint=FALSE;	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::B_WriteAllPinsClick(TObject *Sender)
{
Byte nPin;
  for(nPin=1; nPin<=17; nPin++)
   VicLPT1->Pin[nPin] = CPinWrite[nPin]->Checked;
}
//---------------------------------------------------------------------------
